local f = io.open(minetest.get_worldpath().."/log","wb")
local setup_mode = false
local tests = 1

local F = atlatc.envs.test.fdata

F.trainids = {"994697"}

function F.log_status(status, fmt, ...)
	local msg = string.format("%s: "..fmt, status, ...)
	f:write(msg.."\n")
	minetest.chat_send_all("[TEST] "..msg)
	minetest.log(msg)
end

function F.log_result(result, fmt, ...)
	return F.log_status(result and "PASS" or "FAIL", fmt, ...)
end

function F.log_info(fmt, ...)
	return F.log_status("INFO", fmt, ...)
end

function F.testgroup1(rres, rvel)
	local train = advtrains.trains[F.trainids[1]]
	local tres = train.speed_restriction
	local tvel = train.velocity
	F.log_result(tres == rres, "(Test Group 1) RES: %s expected; got %s", rres, tres)
	if rvel then
		F.log_result(tvel == rvel, "(Test Group 1) VEL: %s expected; got %s", rvel, tvel)
	end
end

function F.done()
	tests = tests - 1
	F.log_info("%d test(s) remaining", tests)
	if tests == 0 and not setup_mode then
		F.log_info("Shutting down in 3 seconds")
		f:flush()
		f:close()
		minetest.after(3, function()
				minetest.request_shutdown("Test complete")
		end)
	end
end

local function atc_send_to_train(id, cmd)
	return advtrains.atc.train_set_command(advtrains.trains[id], cmd, true)
end

function init()
	F.log_info("Test started")
	atc_send_to_train(F.trainids[1], "RSM")
end

minetest.after(10, init)

F.log_info("Starting test in 10 seconds")
